<?php
session_start();

//******************************************************************
// Page centrale de MSP
// Au premier accs, cette page permet d'effectuer installation
// ensuite, charge fichier php en fct du profil
//******************************************************************

//EMPECHER LA MISE EN CACHE
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

//Paramtrage lors du premier accs 1/2 : choix de la langue si le fichier lang.php n'existe pas
if (!file_exists('admin/lang.php')) {
	//affichage de la page permettant de faire son chox
	if (!isset($_POST["langue"])) {
		include("admin/pages/install1.php");
		exit;
	//traitement de la reponse : cration du fichier lang.php, qui sera inclus au dbut de chaque script 
	} else {
		$fichier=fopen('admin/lang.php','w');
		$contenu="<?php\r\n\$langue=\"".$_POST["langue"]."\";\r\ninclude(\"admin/lang/".$_POST["langue"].".php\");\r\n?>";
		fputs($fichier,$contenu);
		fclose($fichier);
	}
}

//charger les chaines de caractres
include("admin/lang.php");
//charger les fonctions
include("admin/fonctions.php");

//Paramtrage lors du premier accs 2/2 : Dfinition des codes admin si le fichier htaccess n'existe pas
if (!file_exists('admin/.htaccess')) {
	//verifier la conformit des infos saisies
	$erreurmsg=false;
	if ($erreurmsg==false and isset($_POST["utilisateur"])) $erreurmsg=verifConformite($_POST["utilisateur"],"utilisateur");
	if ($erreurmsg==false and isset($_POST["motdepasse"])) $erreurmsg=verifConformite($_POST["motdepasse"],"motdepasse");
	if ($erreurmsg==false and isset($_POST["nom"])) $erreurmsg=verifConformite($_POST["nom"],"nom");
	if ($erreurmsg==false and isset($_POST["prenom"])) $erreurmsg=verifConformite($_POST["prenom"],"prenom");
	if ($erreurmsg==false and isset($_POST["nom"])) $_POST["nom"]=filtrerchaine($_POST["nom"]);
	if ($erreurmsg==false and isset($_POST["prenom"])) $_POST["prenom"]=filtrerchaine($_POST["prenom"]);

	//page qui va crer les fichiers .htaccess et .htpasswd pour proteger le repertoire admin qui contient toutes les donnes
	//les archives zip du travail des apprenants pourra tre rcuper ici par telechargement http
	if ($erreurmsg!=false or !isset($_POST["utilisateur"])) {
		include("admin/pages/install2.php");
		exit;
	//traitement de la reponse 
	} else {
		// cration du fichiers .htaccess qui va empecher tout accs au repertoire admin
		$fichier=fopen('admin/.htaccess','w');
		$contenu="deny from all ";
		fputs($fichier,$contenu);
		fclose($fichier);
		//cration du fichier utilisateur
		$fichier=fopen('admin/utilisateurs/'.$_POST["utilisateur"],'w');
		$contenu=$_POST["utilisateur"].':'.crypt($_POST["motdepasse"],'cg').':admin:';
		$contenu.=$_POST["nom"].':'.$_POST["prenom"].':-';
		fputs($fichier,$contenu);
		fclose($fichier);
	}
}

$erreurmsg=false;
//identifier si ncessaire
if (!isset($_SESSION["profil"]) and isset($_POST["utilisateur"]) and isset($_POST["motdepasse"])){
	//voir si un fichier correpondant au nom d'utilisateur existe dans le dossier admin/utilisateurs
	if (!is_file('admin/utilisateurs/'.$_POST["utilisateur"])){
		$erreurmsg=$lang['utilisateurinconnu'];
		unset($_POST["utilisateur"]);
	}

	if ($erreurmsg==false){
		//vrifier que le mot de passe correspond et recuperer les infos
		$fichier=fopen('admin/utilisateurs/'.$_POST["utilisateur"],'r');
		$contenu=fgets($fichier);
		fclose($fichier);
		$codes=array();
		$codes=explode(':',$contenu);
		//le format est login:pass:profil:nom:prenom:groupe
		if (($codes[2]=="apprenant" and $codes[1]==$_POST["motdepasse"]) or $codes[1]==crypt($_POST["motdepasse"],'cg') ){
			$_SESSION["login"]=$codes[0];
			$_SESSION["profil"]=$codes[2];
			$_SESSION["nom"]=$codes[3];
			$_SESSION["prenom"]=$codes[4];
			$_SESSION["groupe"]=$codes[5];
		} else $erreurmsg=$lang['motdepasseincorrect'];
	}
}

//chargement des pages correspondant au profil
if (!isset($_SESSION["profil"])) include("admin/invite.php");
else if ($_SESSION["profil"]=="admin" or $_SESSION["profil"]=="prof") include("admin/admin.php");
else if ($_SESSION["profil"]=="apprenant") include("admin/apprenant.php");
else include("admin/invite.php");


?>